# Copyright 2025, GridLab
# Licensed under the GNU Lesser General Public License (LGPL)

include:
  - project: 'pss-x/support/gitlab-ci-templates/workflow'
    ref: 'main'
    file: '/templates/.default.yml'
 
.configuration-cli: &configuration-cli
  image: registry.gitlab.com/pss-x/support/containers/release-cli:1.0.0@sha256:f85040939f5cdc7b61e8adbbfd49e7b5b86f404acbc203e12d5548c1805b6e1e
  variables:
    RELEASE_CLI_CONVENTIONAL_CHANGELOG_VERSION: 4.1.0
  before_script:
    - |
      if [[ -z "${GL_TOKEN}" ]]; then
        echo -e "\e[31mError: Variable GL_TOKEN is not set."
        exit 1
      fi 
    - git fetch origin $CI_COMMIT_REF_NAME
    - git checkout $CI_COMMIT_REF_NAME
    - git fetch --tags --force
    - git remote set-url origin "https://gitlab-ci:${GL_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git"
    - git config --global user.name "${GITLAB_USER_NAME}"
    - git config --global user.email "${GITLAB_USER_EMAIL}" 
    - npm install --global conventional-changelog-cli@$RELEASE_CLI_CONVENTIONAL_CHANGELOG_VERSION
    # https://unix.stackexchange.com/questions/45583/argument-list-too-long-how-do-i-deal-with-it-without-changing-my-command
    - ulimit -s unlimited
    
.release-cli-workflow-rule:
  rules: 
    - !reference [.allow-release-rule, rules]
    - !reference [.allow-release-candidate-rule, rules]
    - !reference [.allow-development-rule, rules]
    - !reference [.allow-feature-rule, rules] 
    - !reference [.allow-main-rule, rules] 
    - when: never